#include <Ice/Ice.h>
#include <ice.h>

using namespace std;
using namespace MyIceModule;

class l2I : public l2interface {
    public:
    string l2(const string& rs, const Ice::Current& current)
    {
        Ice::CommunicatorPtr ic=current.adapter->getCommunicator();
        string proxystring = "l3@l3.l3"; 
        printf( "l2: The proxystring is %s",proxystring.c_str());
        Ice::ObjectPrx base = ic->stringToProxy(proxystring);
        l3interfacePrx prx = l3interfacePrx::checkedCast(base);
        if(prx == 0) {
            printf( "l2: Invalid Proxy: %s",proxystring.c_str());
            throw "Invalid proxy";
        }
        return prx->l3(rs);
    }
};

int
main(int argc, char *argv[])
{
    int status = 0;
    Ice::CommunicatorPtr ic = 0;
    try {
        ic = Ice::initialize(argc,argv);
        Ice::ObjectAdapterPtr adapter = ic->createObjectAdapter("l2");
        Ice::ObjectPtr object = new l2I();
        adapter->add( object, ic->stringToIdentity("l2"));
        adapter->activate();
        ic->waitForShutdown();
    } catch (const Ice::Exception e) {
        cerr << e << endl;
        status = 1;
    }
    catch (const char* msg) {
        cerr << msg << endl;
        status = 1;
    }
    if (ic != 0) {
        try {
            sleep(2);
            ic->destroy();
        } catch (const Ice::Exception e) {
            cerr << e << endl;
            status = 1;
        }
    }
    exit(status);
}
